/*
    File:       GCLApp.h

    Function:	Useful routines for various GCl apps

    Author:     Andrew Willmott

    Copyright:  (c) 1999, Andrew Willmott
*/

#ifndef __GCLApp__
#define __GCLApp__

#include "gcl/GCLConfig.h"
#include "gcl/SceneLang.h"
#ifndef GCL_NO_GL
#include "gcl/ScenePane.h"
#endif
#include "gcl/Animation.h"

class GCLApp
{
public:
							GCLApp();

	Void					ReadScene(FileName &sceneFile);
	Void					SetAvars(scScenePtr scene);
	Void					SetAvarsFromAnim(scScenePtr scene);
	
// options
	Int						xsize;
	Int						ysize;
	Colour					bgColour;
	Int						noScale;
	Int						zUp;
	Int						zDown;

	static Void				GetFileArgs(Int argc, Char *argv[]);
	static Void				GetAvarArgs(Int argc, Char *argv[]);

	static Char				**files;
	static Int				numFiles;
	static StrConstArray	avarNames;
	static ScalarList		avarVals;

// fields
	scScenePtr				scene;
	scCamera				*itsCamera;
#ifndef GCL_NO_GL
	ScenePane				*itsScenePane;
#endif
	// animation
	Int						frame;
	Double					time;
	Double					fps;
	Animation				*anim;
	scAvarList				*avarList;
};

#endif
