/*
    File:       GLXPane.h

    Function:	

    Author:     Andrew Willmott

    Copyright:  (c) 1999, Andrew Willmott
*/

#ifndef __GLXPane__
#define __GLXPane__

#include "gcl/XGraphicsSystem.h"
#include "gcl/GLRenderer.h"
#include <GL/glx.h>

class GLXPane : public GLRenderer, public XEventPane
// event-handling canvas you can draw into
{
public:
					GLXPane(Bool doubleBuffer = true);
					~GLXPane();

	Void			Init();
	Void			MakeCurrent();
	Void			Show();
	XVisualInfo		*GetVisualInfo();

protected:	
	Bool			doubleBuffered;
	GLXContext		context;

	static XVisualInfo	*sGLXVisualInfo;
	static XVisualInfo	*sGLXDblVisualInfo;
};


class GLXOffscreenPane : public GLRenderer, public XOffscreenPane
// offscreen canvas you can draw into 
{
public:
	
					GLXOffscreenPane();
					~GLXOffscreenPane();

	Void			Init();
	Void			MakeCurrent();
	XVisualInfo		*GetVisualInfo();
	
protected:
	GLXContext		context;
	GLXPixmap		pixmap;

	static XVisualInfo	*sGLXVisualInfo;
};

#endif
