/*
	File:		MRFaceCluster.h

	Function:	

	Author:		Andrew Willmott
*/

#ifndef __MRFaceCluster__
#define __MRFaceCluster__

#include "gcl/Renderer.h"
#include "gcl/Quaternion.h"
#include "cl/NArray.h"

class FaceCluster
{
public:	
    FaceCluster();

    Bool			IsLeaf()
    				{ return(child[0] < 0); }

	Int				child[2];		///< two child clusters

	Quaternion		axesQuat;
					/** OBB coordinate system:
						axis[0] = u axis,
						axis[1] = v axis,
						axis[2] = normal axis.	*/
	Point			min;			///< min point of BB in OBB coord system
	Point			max;			///< max point of BB in OBB coord system

	Vector			areaNormal;
	GCLReal			totArea;
	Byte			sideArea[6];

	Void			GetAxes(VecTrans &axes)
					{ axes.MakeRot(axesQuat); }
	Void			SetAxes(const VecTrans &axes)
					{ axesQuat = MakeQuat(axes); };

	Void			Draw(Renderer &r);
	Void			DrawSideAreas(Renderer &r);
	Void			DrawPlane(Renderer &r);
	Void			DrawBox(Renderer &r, Bool solid);
};

typedef NArray<FaceCluster> FaceClusList;

#endif
