/*
    File:       Readers.h

    Function:	Support for reading in various scene file formats

    Author:     Andrew Willmott

    Copyright:  (c) 1998, Andrew Willmott
*/

#ifndef __Readers__
#define __Readers__

#include "gcl/Scene.h"
#include "cl/FileName.h"

class SceneReader
/// Master scene reading class.
{
public:

	static scScenePtr	Load(FileName &sceneFile);
						///< Load a scene file from sceneFile.
	static Void			PrintSupportedFormats(ostream &s);
						///< Send a list of supported formats to s.
};

#endif
