/*
    File:       Texture.h

    Function:	Provides interface to texture maps

    Author:     Andrew Willmott

    Copyright:  (c) 1998, Andrew Willmott
*/

#ifndef __Texture__
#define __Texture__

#include "gcl/Image.h"
#include "gcl/Geometry.h"

class Texture
{
public:
	Texture(const Texture &tex);
	Texture() : image(0), flags(0) {};

	Int			Load(StrConst str);
	Colour		FilterBox(const Coord &bl, const Coord &ur);

	FileName	textureFile;
	Image		*image;
	UInt32		flags;
};

#endif
